%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
% <--EXCEL REQUIRED-->
%=============================================================================
assert_isequal(nargin('COM_xlsfinfo'), 1);
assert_isequal(nargout('COM_xlsfinfo'), -1);
%=============================================================================
[s, sheets, format] = COM_xlsfinfo([modulepath('com_engine'), '/tests/test_COM_xlsread.m']);
assert_isequal(s, 'Microsoft Excel Spreadsheet');
assert_isequal(sheets, {'test_COM_xlsread'});
assert_isequal(format, 'xlCurrentPlatformText');
%=============================================================================
[s, sheets, format] = COM_xlsfinfo([modulepath('com_engine'), '/tests/format_excel97.xls']);
assert_isequal(s, 'Microsoft Excel Spreadsheet');
assert_isequal(sheets, {'Feuil1', 'Feuil2'});
assert_isequal(format, 'xlExcel8');
%=============================================================================
[s, sheets, format] = COM_xlsfinfo([modulepath('com_engine'), '/tests/sample_xslx.xlsx']);
assert_isequal(s, 'Microsoft Excel Spreadsheet');
assert_isequal(sheets, {'Smile You Can Read Me !'});
assert_isequal(format, 'xlOpenXMLWorkbook');
%=============================================================================
